org.apache.geode.cache.query

## Enum IndexType

- java.lang.Object
- - java.lang.Enum<IndexType>
  - - org.apache.geode.cache.query.IndexType

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<IndexType>

  Deprecated.
  As of 6.6.1. Check `QueryService` for changes. Enumerated type for types of indexes

      public enum IndexType
      extends java.lang.Enum<IndexType>

  Since:
    GemFire 4.0

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `FUNCTIONAL` Deprecated. The index type of a functional index.
    `HASH` Deprecated. Due to the overhead caused by rehashing while expanding the backing array, hash index has been deprecated since Apache Geode 1.4.0. Use `FUNCTIONAL` instead.
    `PRIMARY_KEY` Deprecated. The index type of a primary key index.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getName()` Deprecated.
    `static IndexType` | `valueOf(java.lang.String name)` Deprecated. Returns the enum constant of this type with the specified name.
    `static IndexType` | `valueOfSynonym(java.lang.String name)` Deprecated.
    `static IndexType[]` | `values()` Deprecated. Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### FUNCTIONAL

          public static final IndexType FUNCTIONAL

      Deprecated.
      The index type of a functional index. A functional index is used for the comparison of some function of a region value with a constant, using a relational operator. The indexedExpression yields a value that is a Comparable. The "constant" that it is to be compared to is any expression that is not dependent on a value in the region. A simple example is an index on the indexedExpression "age". This would be used for a query that has the where clause "age < 55".

      The indexedExpression for a functional index can be any Comparable or any of the following primitive types:
      `long int short byte char float double`

      See Also:
        `QueryService.createIndex(String, IndexType, String, String)`

    - #### HASH

          @Deprecated
          public static final IndexType HASH

      Deprecated. Due to the overhead caused by rehashing while expanding the backing array, hash index has been deprecated since Apache Geode 1.4.0. Use `FUNCTIONAL` instead.
      The index type of a hash index. A hash index is used for the comparison of some function of a region value with a constant, using a relational operator. The indexedExpression yields a value that is a Comparable. The "constant" that it is to be compared to is any expression that is not dependent on a value in the region. A simple example is an index on the indexedExpression "age". This would be used for a query that has the where clause "age = 55".

      The indexedExpression for a hash index can be any Comparable or any of the following primitive types:
      `long int short byte char float double`

      See Also:
        `QueryService.createIndex(String, IndexType, String, String)`

    - #### PRIMARY_KEY

          public static final IndexType PRIMARY_KEY

      Deprecated.
      The index type of a primary key index. A primary key index uses the keys in the region itself. By creating a primary key index, you make the query service aware of the relationship between the values in the region and the keys in the region and enable the relationship to be used to optimize the execution of queries. For example, if the values in a region are employee objects and the keys in the region is the attribute empId on those employees, then you can create a primary key index on that region with the indexedExpression "empId".

      The type of the indexedExpression for a primary key index can be any object type. Just as in a Region, the lookup is based on the implementation of the `equals` and `hashCode` methods in the object.

      See Also:
        `QueryService.createIndex(String, IndexType, String, String)`

  - ### Method Detail

    - #### values

          public static IndexType[] values()

      Deprecated.
      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (IndexType c : IndexType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static IndexType valueOf(java.lang.String name)

      Deprecated.
      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### getName

          public java.lang.String getName()

      Deprecated.

    - #### valueOfSynonym

          public static IndexType valueOfSynonym(java.lang.String name)

      Deprecated.